#include "Error.hpp"

#include <stdio.h>
#include <stdarg.h>

namespace SoftWire
{
	const Error Error::INTERNAL("Internal error");

	Error::Error(const char *format, ...)
	{
		buffer[0] = 0;

		va_list argList;

		va_start(argList, format);
		_vsnprintf(buffer, stringMax, format, argList);
		va_end(argList);
	}

	void Error::print() const
	{
		if(buffer[0] == 0)
		{
			printf("error: <Unknown>\n");
		}
		else
		{
			printf("error: %s\n", buffer);
		}
	}
}