#ifndef Loader_hpp
#define Loader_hpp

#include "Encoding.hpp"

namespace SoftWire
{
	typedef unsigned char byte;

	class Loader
	{
	public:
		Loader();

		~Loader();

		const void *callable();

		void addEncoding(const Encoding &encoding);

	private:
		struct Link
		{
			Link();

			~Link();

			void attachNew(const Encoding &encoding);

			Encoding encoding;
			Link *next;
		};

		Link *entry;

		byte *objectCode;

		void loadCode();
		byte *resolveLabel(const char *label) const;
		int codeLength() const;
	};
}

#endif   // Loader_hpp