#ifndef Parser_hpp
#define Parser_hpp

#include "Synthesizer.hpp"
#include "InstructionSet.hpp"
#include "Scanner.hpp"

namespace SoftWire
{
	class Instruction;
	class Token;

	class Parser
	{
	public:
		Parser();

		~Parser();

		const Encoding &parseLine(const char *sourceLine);

	private:
		static const InstructionSet instructionSet;

		Scanner token;
		Instruction *instruction;
		Synthesizer synthesizer;

		void parseLabel();
		void parseMnemonic();
		void parseSpecifier();

		void parseFirstOperand();
		void parseSecondOperand();
		void parseThirdOperand();

		Operand parseImmediate();
		Operand parseRegister();
		Operand parseMemoryReference();
	};
}

#endif   // Parser_hpp