#ifndef Scanner_hpp
#define Scanner_hpp

#include "Token.hpp"

namespace SoftWire
{
	class Scanner : public Token
	{
	public:
		Scanner();

		~Scanner();

		void setSource(const char *source);

		bool isEndOfLine() const;
		bool isIdentifier() const;
		bool isConstant() const;
		bool isPunctuator() const;

		const char *getString() const;
		char getChar() const;
		int getValue() const;

		int stringLength() const;

		const Token &currentToken() const;
		const Token &lookAhead() const;
		const Token &advance(int n = 1);

	private:
		class Link
		{
		public:
			Link();

			~Link();

			Token *token;
			Link *next;
		};

		void assertPointer() const;

		Link *root;
		const Link *pointer;

		enum {tokenMax = 256};   // Maximum token length
	};
}

#endif   // Scanner_hpp